# Bill

## Properties

Name | Type | Description | Notes
------------ | ------------- | ------------- | -------------
**created_at** | Option<**String**> |  | [optional][readonly]
**updated_at** | Option<**String**> |  | [optional][readonly]
**currency_id** | Option<**String**> | Use either currency_id or currency_code | [optional]
**currency_code** | Option<**String**> | Use either currency_id or currency_code | [optional]
**currency_symbol** | Option<**String**> |  | [optional][readonly]
**currency_decimal_places** | Option<**i32**> |  | [optional][readonly]
**name** | **String** |  | 
**amount_min** | **String** |  | 
**amount_max** | **String** |  | 
**date** | **String** |  | 
**end_date** | Option<**String**> | The date after which this bill is no longer valid or applicable | [optional]
**extension_date** | Option<**String**> | The date before which the bill must be renewed (or cancelled) | [optional]
**repeat_freq** | [**models::BillRepeatFrequency**](BillRepeatFrequency.md) |  | 
**skip** | Option<**i32**> | How often the bill must be skipped. 1 means a bi-monthly bill. | [optional]
**active** | Option<**bool**> | If the bill is active. | [optional]
**order** | Option<**i32**> | Order of the bill. | [optional]
**notes** | Option<**String**> |  | [optional]
**next_expected_match** | Option<**String**> | When the bill is expected to be due. | [optional][readonly]
**next_expected_match_diff** | Option<**String**> | Formatted (locally) when the bill is due. | [optional][readonly]
**object_group_id** | Option<**String**> | The group ID of the group this object is part of. NULL if no group. | [optional]
**object_group_order** | Option<**i32**> | The order of the group. At least 1, for the highest sorting. | [optional][readonly]
**object_group_title** | Option<**String**> | The name of the group. NULL if no group. | [optional]
**pay_dates** | Option<**Vec<String>**> | Array of future dates when the bill is expected to be paid. Autogenerated. | [optional][readonly]
**paid_dates** | Option<[**Vec<models::BillPaidDatesInner>**](Bill_paid_dates_inner.md)> | Array of past transactions when the bill was paid. | [optional][readonly]

[[Back to Model list]](../README.md#documentation-for-models) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to README]](../README.md)


