/*
 * Firefly III API v2.1.0
 *
 * This is the documentation of the Firefly III API. You can find accompanying documentation on the website of Firefly III itself (see below). Please report any bugs or issues. You may use the \"Authorize\" button to try the API below. This file was last generated on 2024-09-10T05:07:57+00:00  Please keep in mind that the demo site does not accept requests from curl, colly, wget, etc. You must use a browser or a tool like Postman to make requests. Too many script kiddies out there, sorry about that. 
 *
 * The version of the OpenAPI document: 2.1.0
 * Contact: james@firefly-iii.org
 * Generated by: https://openapi-generator.tech
 */

use crate::models;
use serde::{Deserialize, Serialize};

#[derive(Clone, Default, Debug, PartialEq, Serialize, Deserialize)]
pub struct AutocompleteAccount {
    #[serde(rename = "id")]
    pub id: String,
    /// Name of the account found by an auto-complete search.
    #[serde(rename = "name")]
    pub name: String,
    /// Asset accounts and liabilities have a second field with the given date's account balance.
    #[serde(rename = "name_with_balance")]
    pub name_with_balance: String,
    /// Account type of the account found by the auto-complete search.
    #[serde(rename = "type")]
    pub r#type: String,
    /// ID for the currency used by this account.
    #[serde(rename = "currency_id")]
    pub currency_id: String,
    /// Currency name for the currency used by this account.
    #[serde(rename = "currency_name")]
    pub currency_name: String,
    /// Currency code for the currency used by this account.
    #[serde(rename = "currency_code")]
    pub currency_code: String,
    /// Currency symbol for the currency used by this account.
    #[serde(rename = "currency_symbol")]
    pub currency_symbol: String,
    /// Number of decimal places for the currency used by this account.
    #[serde(rename = "currency_decimal_places")]
    pub currency_decimal_places: i32,
}

impl AutocompleteAccount {
    pub fn new(id: String, name: String, name_with_balance: String, r#type: String, currency_id: String, currency_name: String, currency_code: String, currency_symbol: String, currency_decimal_places: i32) -> AutocompleteAccount {
        AutocompleteAccount {
            id,
            name,
            name_with_balance,
            r#type,
            currency_id,
            currency_name,
            currency_code,
            currency_symbol,
            currency_decimal_places,
        }
    }
}

