/*
 * Firefly III API v2.1.0
 *
 * This is the documentation of the Firefly III API. You can find accompanying documentation on the website of Firefly III itself (see below). Please report any bugs or issues. You may use the \"Authorize\" button to try the API below. This file was last generated on 2024-09-10T05:07:57+00:00  Please keep in mind that the demo site does not accept requests from curl, colly, wget, etc. You must use a browser or a tool like Postman to make requests. Too many script kiddies out there, sorry about that. 
 *
 * The version of the OpenAPI document: 2.1.0
 * Contact: james@firefly-iii.org
 * Generated by: https://openapi-generator.tech
 */

use crate::models;
use serde::{Deserialize, Serialize};

/// ConfigValueFilter : Title of the configuration value.
/// Title of the configuration value.
#[derive(Clone, Copy, Debug, Eq, PartialEq, Ord, PartialOrd, Hash, Serialize, Deserialize)]
pub enum ConfigValueFilter {
    #[serde(rename = "configuration.is_demo_site")]
    ConfigurationPeriodIsDemoSite,
    #[serde(rename = "configuration.permission_update_check")]
    ConfigurationPeriodPermissionUpdateCheck,
    #[serde(rename = "configuration.last_update_check")]
    ConfigurationPeriodLastUpdateCheck,
    #[serde(rename = "configuration.single_user_mode")]
    ConfigurationPeriodSingleUserMode,
    #[serde(rename = "firefly.version")]
    FireflyPeriodVersion,
    #[serde(rename = "firefly.api_version")]
    FireflyPeriodApiVersion,
    #[serde(rename = "firefly.default_location")]
    FireflyPeriodDefaultLocation,
    #[serde(rename = "firefly.account_to_transaction")]
    FireflyPeriodAccountToTransaction,
    #[serde(rename = "firefly.allowed_opposing_types")]
    FireflyPeriodAllowedOpposingTypes,
    #[serde(rename = "firefly.accountRoles")]
    FireflyPeriodAccountRoles,
    #[serde(rename = "firefly.valid_liabilities")]
    FireflyPeriodValidLiabilities,
    #[serde(rename = "firefly.interest_periods")]
    FireflyPeriodInterestPeriods,
    #[serde(rename = "firefly.enable_external_map")]
    FireflyPeriodEnableExternalMap,
    #[serde(rename = "firefly.expected_source_types")]
    FireflyPeriodExpectedSourceTypes,
    #[serde(rename = "app.timezone")]
    AppPeriodTimezone,
    #[serde(rename = "firefly.bill_periods")]
    FireflyPeriodBillPeriods,
    #[serde(rename = "firefly.credit_card_types")]
    FireflyPeriodCreditCardTypes,
    #[serde(rename = "firefly.languages")]
    FireflyPeriodLanguages,
    #[serde(rename = "firefly.valid_view_ranges")]
    FireflyPeriodValidViewRanges,

}

impl std::fmt::Display for ConfigValueFilter {
    fn fmt(&self, f: &mut std::fmt::Formatter) -> std::fmt::Result {
        match self {
            Self::ConfigurationPeriodIsDemoSite => write!(f, "configuration.is_demo_site"),
            Self::ConfigurationPeriodPermissionUpdateCheck => write!(f, "configuration.permission_update_check"),
            Self::ConfigurationPeriodLastUpdateCheck => write!(f, "configuration.last_update_check"),
            Self::ConfigurationPeriodSingleUserMode => write!(f, "configuration.single_user_mode"),
            Self::FireflyPeriodVersion => write!(f, "firefly.version"),
            Self::FireflyPeriodApiVersion => write!(f, "firefly.api_version"),
            Self::FireflyPeriodDefaultLocation => write!(f, "firefly.default_location"),
            Self::FireflyPeriodAccountToTransaction => write!(f, "firefly.account_to_transaction"),
            Self::FireflyPeriodAllowedOpposingTypes => write!(f, "firefly.allowed_opposing_types"),
            Self::FireflyPeriodAccountRoles => write!(f, "firefly.accountRoles"),
            Self::FireflyPeriodValidLiabilities => write!(f, "firefly.valid_liabilities"),
            Self::FireflyPeriodInterestPeriods => write!(f, "firefly.interest_periods"),
            Self::FireflyPeriodEnableExternalMap => write!(f, "firefly.enable_external_map"),
            Self::FireflyPeriodExpectedSourceTypes => write!(f, "firefly.expected_source_types"),
            Self::AppPeriodTimezone => write!(f, "app.timezone"),
            Self::FireflyPeriodBillPeriods => write!(f, "firefly.bill_periods"),
            Self::FireflyPeriodCreditCardTypes => write!(f, "firefly.credit_card_types"),
            Self::FireflyPeriodLanguages => write!(f, "firefly.languages"),
            Self::FireflyPeriodValidViewRanges => write!(f, "firefly.valid_view_ranges"),
        }
    }
}

impl Default for ConfigValueFilter {
    fn default() -> ConfigValueFilter {
        Self::ConfigurationPeriodIsDemoSite
    }
}

