/*
 * Firefly III API v2.1.0
 *
 * This is the documentation of the Firefly III API. You can find accompanying documentation on the website of Firefly III itself (see below). Please report any bugs or issues. You may use the \"Authorize\" button to try the API below. This file was last generated on 2024-09-10T05:07:57+00:00  Please keep in mind that the demo site does not accept requests from curl, colly, wget, etc. You must use a browser or a tool like Postman to make requests. Too many script kiddies out there, sorry about that. 
 *
 * The version of the OpenAPI document: 2.1.0
 * Contact: james@firefly-iii.org
 * Generated by: https://openapi-generator.tech
 */

use crate::models;
use serde::{Deserialize, Serialize};

#[derive(Clone, Default, Debug, PartialEq, Serialize, Deserialize)]
pub struct InsightTransferEntry {
    /// This ID is a reference to the original object.
    #[serde(rename = "id", skip_serializing_if = "Option::is_none")]
    pub id: Option<String>,
    /// This is the name of the object.
    #[serde(rename = "name", skip_serializing_if = "Option::is_none")]
    pub name: Option<String>,
    /// The total amount transferred between start date and end date, a number defined as a string, for this asset account.
    #[serde(rename = "difference", skip_serializing_if = "Option::is_none")]
    pub difference: Option<String>,
    /// The total amount transferred between start date and end date, a number as a float, for this asset account. May have rounding errors.
    #[serde(rename = "difference_float", skip_serializing_if = "Option::is_none")]
    pub difference_float: Option<f64>,
    /// The total amount transferred TO this account between start date and end date, a number defined as a string, for this asset account.
    #[serde(rename = "in", skip_serializing_if = "Option::is_none")]
    pub r#in: Option<String>,
    /// The total amount transferred FROM this account between start date and end date, a number as a float, for this asset account. May have rounding errors.
    #[serde(rename = "in_float", skip_serializing_if = "Option::is_none")]
    pub in_float: Option<f64>,
    /// The total amount transferred FROM this account between start date and end date, a number defined as a string, for this asset account.
    #[serde(rename = "out", skip_serializing_if = "Option::is_none")]
    pub out: Option<String>,
    /// The total amount transferred TO this account between start date and end date, a number as a float, for this asset account. May have rounding errors.
    #[serde(rename = "out_float", skip_serializing_if = "Option::is_none")]
    pub out_float: Option<f64>,
    /// The currency ID of the expenses listed for this account.
    #[serde(rename = "currency_id", skip_serializing_if = "Option::is_none")]
    pub currency_id: Option<String>,
    /// The currency code of the expenses listed for this account.
    #[serde(rename = "currency_code", skip_serializing_if = "Option::is_none")]
    pub currency_code: Option<String>,
}

impl InsightTransferEntry {
    pub fn new() -> InsightTransferEntry {
        InsightTransferEntry {
            id: None,
            name: None,
            difference: None,
            difference_float: None,
            r#in: None,
            in_float: None,
            out: None,
            out_float: None,
            currency_id: None,
            currency_code: None,
        }
    }
}

