/*
 * Firefly III API v2.1.0
 *
 * This is the documentation of the Firefly III API. You can find accompanying documentation on the website of Firefly III itself (see below). Please report any bugs or issues. You may use the \"Authorize\" button to try the API below. This file was last generated on 2024-09-10T05:07:57+00:00  Please keep in mind that the demo site does not accept requests from curl, colly, wget, etc. You must use a browser or a tool like Postman to make requests. Too many script kiddies out there, sorry about that. 
 *
 * The version of the OpenAPI document: 2.1.0
 * Contact: james@firefly-iii.org
 * Generated by: https://openapi-generator.tech
 */

use crate::models;
use serde::{Deserialize, Serialize};

#[derive(Clone, Default, Debug, PartialEq, Serialize, Deserialize)]
pub struct PiggyBankUpdate {
    #[serde(rename = "name", skip_serializing_if = "Option::is_none")]
    pub name: Option<String>,
    /// The ID of the asset account this piggy bank is connected to.
    #[serde(rename = "account_id", skip_serializing_if = "Option::is_none")]
    pub account_id: Option<String>,
    #[serde(rename = "currency_id", skip_serializing_if = "Option::is_none")]
    pub currency_id: Option<String>,
    #[serde(rename = "currency_code", skip_serializing_if = "Option::is_none")]
    pub currency_code: Option<String>,
    #[serde(rename = "target_amount", default, with = "::serde_with::rust::double_option", skip_serializing_if = "Option::is_none")]
    pub target_amount: Option<Option<String>>,
    #[serde(rename = "current_amount", skip_serializing_if = "Option::is_none")]
    pub current_amount: Option<String>,
    /// The date you started with this piggy bank.
    #[serde(rename = "start_date", skip_serializing_if = "Option::is_none")]
    pub start_date: Option<String>,
    /// The date you intend to finish saving money.
    #[serde(rename = "target_date", default, with = "::serde_with::rust::double_option", skip_serializing_if = "Option::is_none")]
    pub target_date: Option<Option<String>>,
    #[serde(rename = "order", skip_serializing_if = "Option::is_none")]
    pub order: Option<i32>,
    #[serde(rename = "active", skip_serializing_if = "Option::is_none")]
    pub active: Option<bool>,
    #[serde(rename = "notes", default, with = "::serde_with::rust::double_option", skip_serializing_if = "Option::is_none")]
    pub notes: Option<Option<String>>,
    /// The group ID of the group this object is part of. NULL if no group.
    #[serde(rename = "object_group_id", default, with = "::serde_with::rust::double_option", skip_serializing_if = "Option::is_none")]
    pub object_group_id: Option<Option<String>>,
    /// The name of the group. NULL if no group.
    #[serde(rename = "object_group_title", default, with = "::serde_with::rust::double_option", skip_serializing_if = "Option::is_none")]
    pub object_group_title: Option<Option<String>>,
}

impl PiggyBankUpdate {
    pub fn new() -> PiggyBankUpdate {
        PiggyBankUpdate {
            name: None,
            account_id: None,
            currency_id: None,
            currency_code: None,
            target_amount: None,
            current_amount: None,
            start_date: None,
            target_date: None,
            order: None,
            active: None,
            notes: None,
            object_group_id: None,
            object_group_title: None,
        }
    }
}

