/*
 * Firefly III API v2.1.0
 *
 * This is the documentation of the Firefly III API. You can find accompanying documentation on the website of Firefly III itself (see below). Please report any bugs or issues. You may use the \"Authorize\" button to try the API below. This file was last generated on 2024-09-10T05:07:57+00:00  Please keep in mind that the demo site does not accept requests from curl, colly, wget, etc. You must use a browser or a tool like Postman to make requests. Too many script kiddies out there, sorry about that. 
 *
 * The version of the OpenAPI document: 2.1.0
 * Contact: james@firefly-iii.org
 * Generated by: https://openapi-generator.tech
 */

use crate::models;
use serde::{Deserialize, Serialize};

#[derive(Clone, Default, Debug, PartialEq, Serialize, Deserialize)]
pub struct RecurrenceTransactionUpdate {
    #[serde(rename = "id")]
    pub id: String,
    #[serde(rename = "description", skip_serializing_if = "Option::is_none")]
    pub description: Option<String>,
    /// Amount of the transaction.
    #[serde(rename = "amount", skip_serializing_if = "Option::is_none")]
    pub amount: Option<String>,
    /// Foreign amount of the transaction.
    #[serde(rename = "foreign_amount", default, with = "::serde_with::rust::double_option", skip_serializing_if = "Option::is_none")]
    pub foreign_amount: Option<Option<String>>,
    /// Submit either a currency_id or a currency_code.
    #[serde(rename = "currency_id", skip_serializing_if = "Option::is_none")]
    pub currency_id: Option<String>,
    /// Submit either a currency_id or a currency_code.
    #[serde(rename = "currency_code", skip_serializing_if = "Option::is_none")]
    pub currency_code: Option<String>,
    /// Submit either a foreign_currency_id or a foreign_currency_code, or neither.
    #[serde(rename = "foreign_currency_id", default, with = "::serde_with::rust::double_option", skip_serializing_if = "Option::is_none")]
    pub foreign_currency_id: Option<Option<String>>,
    /// The budget ID for this transaction.
    #[serde(rename = "budget_id", skip_serializing_if = "Option::is_none")]
    pub budget_id: Option<String>,
    /// Category ID for this transaction.
    #[serde(rename = "category_id", skip_serializing_if = "Option::is_none")]
    pub category_id: Option<String>,
    /// ID of the source account. Submit either this or source_name.
    #[serde(rename = "source_id", skip_serializing_if = "Option::is_none")]
    pub source_id: Option<String>,
    /// ID of the destination account. Submit either this or destination_name.
    #[serde(rename = "destination_id", skip_serializing_if = "Option::is_none")]
    pub destination_id: Option<String>,
    /// Array of tags.
    #[serde(rename = "tags", default, with = "::serde_with::rust::double_option", skip_serializing_if = "Option::is_none")]
    pub tags: Option<Option<Vec<String>>>,
    #[serde(rename = "piggy_bank_id", default, with = "::serde_with::rust::double_option", skip_serializing_if = "Option::is_none")]
    pub piggy_bank_id: Option<Option<String>>,
    /// Optional.
    #[serde(rename = "bill_id", default, with = "::serde_with::rust::double_option", skip_serializing_if = "Option::is_none")]
    pub bill_id: Option<Option<String>>,
}

impl RecurrenceTransactionUpdate {
    pub fn new(id: String) -> RecurrenceTransactionUpdate {
        RecurrenceTransactionUpdate {
            id,
            description: None,
            amount: None,
            foreign_amount: None,
            currency_id: None,
            currency_code: None,
            foreign_currency_id: None,
            budget_id: None,
            category_id: None,
            source_id: None,
            destination_id: None,
            tags: None,
            piggy_bank_id: None,
            bill_id: None,
        }
    }
}

