/*
 * Firefly III API v2.1.0
 *
 * This is the documentation of the Firefly III API. You can find accompanying documentation on the website of Firefly III itself (see below). Please report any bugs or issues. You may use the \"Authorize\" button to try the API below. This file was last generated on 2024-09-10T05:07:57+00:00  Please keep in mind that the demo site does not accept requests from curl, colly, wget, etc. You must use a browser or a tool like Postman to make requests. Too many script kiddies out there, sorry about that. 
 *
 * The version of the OpenAPI document: 2.1.0
 * Contact: james@firefly-iii.org
 * Generated by: https://openapi-generator.tech
 */

use crate::models;
use serde::{Deserialize, Serialize};

#[derive(Clone, Default, Debug, PartialEq, Serialize, Deserialize)]
pub struct Rule {
    #[serde(rename = "created_at", skip_serializing_if = "Option::is_none")]
    pub created_at: Option<String>,
    #[serde(rename = "updated_at", skip_serializing_if = "Option::is_none")]
    pub updated_at: Option<String>,
    #[serde(rename = "title")]
    pub title: String,
    #[serde(rename = "description", skip_serializing_if = "Option::is_none")]
    pub description: Option<String>,
    /// ID of the rule group under which the rule must be stored. Either this field or rule_group_title is mandatory.
    #[serde(rename = "rule_group_id")]
    pub rule_group_id: String,
    /// Title of the rule group under which the rule must be stored. Either this field or rule_group_id is mandatory.
    #[serde(rename = "rule_group_title", skip_serializing_if = "Option::is_none")]
    pub rule_group_title: Option<String>,
    #[serde(rename = "order", skip_serializing_if = "Option::is_none")]
    pub order: Option<i32>,
    #[serde(rename = "trigger")]
    pub trigger: models::RuleTriggerType,
    /// Whether or not the rule is even active. Default is true.
    #[serde(rename = "active", skip_serializing_if = "Option::is_none")]
    pub active: Option<bool>,
    /// If the rule is set to be strict, ALL triggers must hit in order for the rule to fire. Otherwise, just one is enough. Default value is true.
    #[serde(rename = "strict", skip_serializing_if = "Option::is_none")]
    pub strict: Option<bool>,
    /// If this value is true and the rule is triggered, other rules  after this one in the group will be skipped. Default value is false.
    #[serde(rename = "stop_processing", skip_serializing_if = "Option::is_none")]
    pub stop_processing: Option<bool>,
    #[serde(rename = "triggers")]
    pub triggers: Vec<models::RuleTrigger>,
    #[serde(rename = "actions")]
    pub actions: Vec<models::RuleAction>,
}

impl Rule {
    pub fn new(title: String, rule_group_id: String, trigger: models::RuleTriggerType, triggers: Vec<models::RuleTrigger>, actions: Vec<models::RuleAction>) -> Rule {
        Rule {
            created_at: None,
            updated_at: None,
            title,
            description: None,
            rule_group_id,
            rule_group_title: None,
            order: None,
            trigger,
            active: None,
            strict: None,
            stop_processing: None,
            triggers,
            actions,
        }
    }
}

