/*
 * Firefly III API v2.1.0
 *
 * This is the documentation of the Firefly III API. You can find accompanying documentation on the website of Firefly III itself (see below). Please report any bugs or issues. You may use the \"Authorize\" button to try the API below. This file was last generated on 2024-09-10T05:07:57+00:00  Please keep in mind that the demo site does not accept requests from curl, colly, wget, etc. You must use a browser or a tool like Postman to make requests. Too many script kiddies out there, sorry about that. 
 *
 * The version of the OpenAPI document: 2.1.0
 * Contact: james@firefly-iii.org
 * Generated by: https://openapi-generator.tech
 */

use crate::models;
use serde::{Deserialize, Serialize};

/// RuleActionKeyword : The type of thing this action will do. A limited set is possible.
/// The type of thing this action will do. A limited set is possible.
#[derive(Clone, Copy, Debug, Eq, PartialEq, Ord, PartialOrd, Hash, Serialize, Deserialize)]
pub enum RuleActionKeyword {
    #[serde(rename = "user_action")]
    UserAction,
    #[serde(rename = "set_category")]
    SetCategory,
    #[serde(rename = "clear_category")]
    ClearCategory,
    #[serde(rename = "set_budget")]
    SetBudget,
    #[serde(rename = "clear_budget")]
    ClearBudget,
    #[serde(rename = "add_tag")]
    AddTag,
    #[serde(rename = "remove_tag")]
    RemoveTag,
    #[serde(rename = "remove_all_tags")]
    RemoveAllTags,
    #[serde(rename = "set_description")]
    SetDescription,
    #[serde(rename = "append_description")]
    AppendDescription,
    #[serde(rename = "prepend_description")]
    PrependDescription,
    #[serde(rename = "set_source_account")]
    SetSourceAccount,
    #[serde(rename = "set_destination_account")]
    SetDestinationAccount,
    #[serde(rename = "set_notes")]
    SetNotes,
    #[serde(rename = "append_notes")]
    AppendNotes,
    #[serde(rename = "prepend_notes")]
    PrependNotes,
    #[serde(rename = "clear_notes")]
    ClearNotes,
    #[serde(rename = "link_to_bill")]
    LinkToBill,
    #[serde(rename = "convert_withdrawal")]
    ConvertWithdrawal,
    #[serde(rename = "convert_deposit")]
    ConvertDeposit,
    #[serde(rename = "convert_transfer")]
    ConvertTransfer,
    #[serde(rename = "delete_transaction")]
    DeleteTransaction,

}

impl std::fmt::Display for RuleActionKeyword {
    fn fmt(&self, f: &mut std::fmt::Formatter) -> std::fmt::Result {
        match self {
            Self::UserAction => write!(f, "user_action"),
            Self::SetCategory => write!(f, "set_category"),
            Self::ClearCategory => write!(f, "clear_category"),
            Self::SetBudget => write!(f, "set_budget"),
            Self::ClearBudget => write!(f, "clear_budget"),
            Self::AddTag => write!(f, "add_tag"),
            Self::RemoveTag => write!(f, "remove_tag"),
            Self::RemoveAllTags => write!(f, "remove_all_tags"),
            Self::SetDescription => write!(f, "set_description"),
            Self::AppendDescription => write!(f, "append_description"),
            Self::PrependDescription => write!(f, "prepend_description"),
            Self::SetSourceAccount => write!(f, "set_source_account"),
            Self::SetDestinationAccount => write!(f, "set_destination_account"),
            Self::SetNotes => write!(f, "set_notes"),
            Self::AppendNotes => write!(f, "append_notes"),
            Self::PrependNotes => write!(f, "prepend_notes"),
            Self::ClearNotes => write!(f, "clear_notes"),
            Self::LinkToBill => write!(f, "link_to_bill"),
            Self::ConvertWithdrawal => write!(f, "convert_withdrawal"),
            Self::ConvertDeposit => write!(f, "convert_deposit"),
            Self::ConvertTransfer => write!(f, "convert_transfer"),
            Self::DeleteTransaction => write!(f, "delete_transaction"),
        }
    }
}

impl Default for RuleActionKeyword {
    fn default() -> RuleActionKeyword {
        Self::UserAction
    }
}

