/*
 * Firefly III API v2.1.0
 *
 * This is the documentation of the Firefly III API. You can find accompanying documentation on the website of Firefly III itself (see below). Please report any bugs or issues. You may use the \"Authorize\" button to try the API below. This file was last generated on 2024-09-10T05:07:57+00:00  Please keep in mind that the demo site does not accept requests from curl, colly, wget, etc. You must use a browser or a tool like Postman to make requests. Too many script kiddies out there, sorry about that. 
 *
 * The version of the OpenAPI document: 2.1.0
 * Contact: james@firefly-iii.org
 * Generated by: https://openapi-generator.tech
 */

use crate::models;
use serde::{Deserialize, Serialize};

#[derive(Clone, Default, Debug, PartialEq, Serialize, Deserialize)]
pub struct RuleTrigger {
    #[serde(rename = "id", skip_serializing_if = "Option::is_none")]
    pub id: Option<String>,
    #[serde(rename = "created_at", skip_serializing_if = "Option::is_none")]
    pub created_at: Option<String>,
    #[serde(rename = "updated_at", skip_serializing_if = "Option::is_none")]
    pub updated_at: Option<String>,
    #[serde(rename = "type")]
    pub r#type: models::RuleTriggerKeyword,
    /// The accompanying value the trigger responds to. This value is often mandatory, but this depends on the trigger.
    #[serde(rename = "value")]
    pub value: String,
    /// If 'prohibited' is true, this rule trigger will be negated. 'Description is' will become 'Description is NOT' etc.
    #[serde(rename = "prohibited", skip_serializing_if = "Option::is_none")]
    pub prohibited: Option<bool>,
    /// Order of the trigger
    #[serde(rename = "order", skip_serializing_if = "Option::is_none")]
    pub order: Option<i32>,
    /// If the trigger is active. Defaults to true.
    #[serde(rename = "active", skip_serializing_if = "Option::is_none")]
    pub active: Option<bool>,
    /// When true, other triggers will not be checked if this trigger was triggered. Defaults to false.
    #[serde(rename = "stop_processing", skip_serializing_if = "Option::is_none")]
    pub stop_processing: Option<bool>,
}

impl RuleTrigger {
    pub fn new(r#type: models::RuleTriggerKeyword, value: String) -> RuleTrigger {
        RuleTrigger {
            id: None,
            created_at: None,
            updated_at: None,
            r#type,
            value,
            prohibited: None,
            order: None,
            active: None,
            stop_processing: None,
        }
    }
}

