/*
 * Firefly III API v2.1.0
 *
 * This is the documentation of the Firefly III API. You can find accompanying documentation on the website of Firefly III itself (see below). Please report any bugs or issues. You may use the \"Authorize\" button to try the API below. This file was last generated on 2024-09-10T05:07:57+00:00  Please keep in mind that the demo site does not accept requests from curl, colly, wget, etc. You must use a browser or a tool like Postman to make requests. Too many script kiddies out there, sorry about that. 
 *
 * The version of the OpenAPI document: 2.1.0
 * Contact: james@firefly-iii.org
 * Generated by: https://openapi-generator.tech
 */

use crate::models;
use serde::{Deserialize, Serialize};

#[derive(Clone, Default, Debug, PartialEq, Serialize, Deserialize)]
pub struct WebhookMessage {
    #[serde(rename = "created_at", skip_serializing_if = "Option::is_none")]
    pub created_at: Option<String>,
    #[serde(rename = "updated_at", skip_serializing_if = "Option::is_none")]
    pub updated_at: Option<String>,
    /// If this message is sent yet.
    #[serde(rename = "sent", skip_serializing_if = "Option::is_none")]
    pub sent: Option<bool>,
    /// If this message has errored out.
    #[serde(rename = "errored", skip_serializing_if = "Option::is_none")]
    pub errored: Option<bool>,
    /// The ID of the webhook this message belongs to.
    #[serde(rename = "webhook_id", skip_serializing_if = "Option::is_none")]
    pub webhook_id: Option<String>,
    /// Long UUID string for identification of this webhook message.
    #[serde(rename = "uuid", skip_serializing_if = "Option::is_none")]
    pub uuid: Option<String>,
    /// The actual message that is sent or will be sent as JSON string.
    #[serde(rename = "message", default, with = "::serde_with::rust::double_option", skip_serializing_if = "Option::is_none")]
    pub message: Option<Option<String>>,
}

impl WebhookMessage {
    pub fn new() -> WebhookMessage {
        WebhookMessage {
            created_at: None,
            updated_at: None,
            sent: None,
            errored: None,
            webhook_id: None,
            uuid: None,
            message: None,
        }
    }
}

